commit:     6b500d11985a1db9735c1fecb8614faa2dfdf5d5
Author:     Tomáš Mózes <hydrapolic <AT> gmail <DOT> com>
AuthorDate: Fri Apr 14 16:46:07 2023 +0000
Commit:     Florian Schmaus <flow <AT> gentoo <DOT> org>
CommitDate: Mon Apr 17 08:12:50 2023 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=6b500d11

app-emulation/xen: add upstream patches

Signed-off-by: Tomáš Mózes <hydrapolic <AT> gmail.com>
Signed-off-by: Florian Schmaus <flow <AT> gentoo.org>

 app-emulation/xen/Manifest               |   2 +
 app-emulation/xen/xen-4.15.5_pre1.ebuild | 187 +++++++++++++++++++++++++++++++
 app-emulation/xen/xen-4.16.4_pre1.ebuild | 174 ++++++++++++++++++++++++++++
 3 files changed, 363 insertions(+)

diff --git a/app-emulation/xen/Manifest b/app-emulation/xen/Manifest
index 732977659c67..a8e802ef87b4 100644
--- a/app-emulation/xen/Manifest
+++ b/app-emulation/xen/Manifest
@@ -1,3 +1,5 @@
 DIST xen-4.15.4.tar.gz 40820669 BLAKE2B 
22edaf817851856c777d02b5211be932c1731bf50fb582545f948c7e8f871937f7c94636496a480642fa7ed8222e12dda091a06638c75b9ee935f3ff9bc2aea0
 SHA512 
fa6a4991c0699025af163ed117f8d0523c0a482102464615025eb3575d755ffacec5df394e3fe01871cde6028678f654d99f8e3c2533b138765971a2a7994cb8
 DIST xen-4.16.3.tar.gz 45003057 BLAKE2B 
6092cff33bffed1b6133daf8d3ce53c57204297e66df6ac58266b2da8d5585df62ae718cc8afaad36ebe6dabdce65b9979b0d13b88e60f2b23c01be21ae4db8e
 SHA512 
b8cbd6f95681de5f824ada2d3cbe0653a38514a18df0dafcf811fb255219c7abec96f46217bdb0c83e1119f685da9a6af7194eeaa94f1cc3c892702782133b4f
 DIST xen-gentoo-patches-4.16.1-gentoo-patchset-2.tar.bz2 5403 BLAKE2B 
7fa3b4aa123b2deed260d02b8d34a35dd205207038edb92569278b25c6fe32e0f0e3857c07755553e047f0eb0d9fe7f8b0816e0f3d7f68aee7929afaf6611dfd
 SHA512 
9e7d25640b24235acf756b031b8b7cee582dded65fe7b94a706c990232e9704d574036c3a9605f285e8e9534578d100a3f38719b27b22775f17ef8f68287997e
+DIST xen-upstream-patches-4.15.5-pre-patchset-0.tar.bz2 21880 BLAKE2B 
89ef7b8cc56ca5a4738ce665aaa3461b61c554088b1b727e34ea417beb43f9b8eae403bae50449c0c96e79ff4b71edf9b6808071b1ca8f0b3878bf1cb9697c6e
 SHA512 
0752d699168e3c2ba13a0ad886dd1d1f9affefc5e7fed9980b2a634012508f405c2accfcd7e92f79016bb869d2d0b09139266a952cc203bea37870fc7d910e51
+DIST xen-upstream-patches-4.16.4-pre-patchset-0.tar.bz2 60151 BLAKE2B 
5c8a8f772ba6be5f776b3270b9f1e64df35c2be7b4e238262eb4ec6b4859576b3ecb448880e1e05ad53dbdaa71643e678978151b10d0d47c901ab3e3518b7eb0
 SHA512 
b33a9b2f602f18165e048ef6a339bc5bf3f800fb1f2449e2e1a6090774ce3ef07b1d7ea8e9e6449fae7b91afcc1a6e281c1bb218a56bca74ba7f12b491fab186

diff --git a/app-emulation/xen/xen-4.15.5_pre1.ebuild 
b/app-emulation/xen/xen-4.15.5_pre1.ebuild
new file mode 100644
index 000000000000..625298cde5de
--- /dev/null
+++ b/app-emulation/xen/xen-4.15.5_pre1.ebuild
@@ -0,0 +1,187 @@
+# Copyright 1999-2023 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+PYTHON_COMPAT=( python3_{9..10} )
+
+inherit flag-o-matic mount-boot python-any-r1 toolchain-funcs
+
+if [[ ${PV} == *9999 ]]; then
+       inherit git-r3
+       EGIT_REPO_URI="git://xenbits.xen.org/xen.git"
+       SRC_URI=""
+else
+       KEYWORDS="~amd64 ~arm -x86"
+
+       XEN_GENTOO_PATCHSET_NUM=
+       XEN_GENTOO_PATCHSET_BASE=
+       XEN_PRE_PATCHSET_NUM=0
+       XEN_PRE_VERSION_BASE=4.15.4
+
+       XEN_BASE_PV="${PV}"
+       if [[ -n "${XEN_PRE_VERSION_BASE}" ]]; then
+               XEN_BASE_PV="${XEN_PRE_VERSION_BASE}"
+       fi
+       if [[ -z "${XEN_GENTOO_PATCHSET_BASE}" ]]; then
+               XEN_GENTOO_PATCHSET_BASE="${XEN_BASE_PV}"
+       fi
+
+       
SRC_URI="https://downloads.xenproject.org/release/xen/${XEN_BASE_PV}/xen-${XEN_BASE_PV}.tar.gz";
+
+       if [[ -n "${XEN_PRE_PATCHSET_NUM}" ]]; then
+               XEN_UPSTREAM_PATCHES_TAG="$(ver_cut 
1-3)-pre-patchset-${XEN_PRE_PATCHSET_NUM}"
+               
XEN_UPSTREAM_PATCHES_NAME="xen-upstream-patches-${XEN_UPSTREAM_PATCHES_TAG}"
+               SRC_URI+=" 
https://gitweb.gentoo.org/proj/xen-upstream-patches.git/snapshot/${XEN_UPSTREAM_PATCHES_NAME}.tar.bz2";
+               
XEN_UPSTREAM_PATCHES_DIR="${WORKDIR}/${XEN_UPSTREAM_PATCHES_NAME}"
+       fi
+       if [[ -n "${XEN_GENTOO_PATCHSET_NUM}" ]]; then
+               XEN_GENTOO_PATCHES_TAG="$(ver_cut 1-3 
${XEN_BASE_PV})-gentoo-patchset-${XEN_GENTOO_PATCHSET_NUM}"
+               
XEN_GENTOO_PATCHES_NAME="xen-gentoo-patches-${XEN_GENTOO_PATCHES_TAG}"
+               SRC_URI+=" 
https://gitweb.gentoo.org/proj/xen-gentoo-patches.git/snapshot/${XEN_GENTOO_PATCHES_NAME}.tar.bz2";
+               XEN_GENTOO_PATCHES_DIR="${WORKDIR}/${XEN_GENTOO_PATCHES_NAME}"
+       fi
+fi
+
+DESCRIPTION="The Xen virtual machine monitor"
+HOMEPAGE="https://xenproject.org";
+
+S="${WORKDIR}/xen-$(ver_cut 1-3 ${XEN_BASE_PV})"
+
+LICENSE="GPL-2"
+SLOT="0"
+IUSE="debug efi flask"
+REQUIRED_USE="arm? ( debug )"
+
+DEPEND="${PYTHON_DEPS}
+       efi? ( >=sys-devel/binutils-2.22[multitarget] )
+       !efi? ( >=sys-devel/binutils-2.22 )
+       flask? ( sys-apps/checkpolicy )"
+RDEPEND=""
+PDEPEND="~app-emulation/xen-tools-${PV}"
+
+# no tests are available for the hypervisor
+# prevent the silliness of /usr/lib/debug/usr/lib/debug files
+# prevent stripping of the debug info from the /usr/lib/debug/xen-syms
+RESTRICT="test splitdebug strip"
+
+# Approved by QA team in bug #144032
+QA_WX_LOAD="boot/xen-syms-${PV}"
+
+pkg_setup() {
+       python-any-r1_pkg_setup
+       if [[ -z ${XEN_TARGET_ARCH} ]]; then
+               if use amd64; then
+                       export XEN_TARGET_ARCH="x86_64"
+               elif use arm; then
+                       export XEN_TARGET_ARCH="arm32"
+               elif use arm64; then
+                       export XEN_TARGET_ARCH="arm64"
+               else
+                       die "Unsupported architecture!"
+               fi
+       fi
+}
+
+src_prepare() {
+       if [[ -v XEN_UPSTREAM_PATCHES_DIR ]]; then
+               eapply "${XEN_UPSTREAM_PATCHES_DIR}"
+       fi
+
+       if [[ -v XEN_GENTOO_PATCHES_DIR ]]; then
+               eapply "${XEN_GENTOO_PATCHES_DIR}"
+       fi
+
+       eapply "${FILESDIR}"/${PN}-4.15-efi.patch
+
+       # Enable XSM-FLASK
+       use flask && eapply "${FILESDIR}"/${PN}-4.15-flask.patch
+
+       # Workaround new gcc-11 options
+       sed -e '/^CFLAGS/s/-Werror//g' -i xen/Makefile || die
+
+       # Drop .config
+       sed -e '/-include $(XEN_ROOT)\/.config/d' -i Config.mk || die "Couldn't 
drop"
+
+       if use efi; then
+               export EFI_VENDOR="gentoo"
+               export EFI_MOUNTPOINT="/boot"
+       fi
+
+       default
+}
+
+xen_make() {
+       # Setting clang to either 'y' or 'n' tells Xen's build system
+       # whether or not clang is used.
+       local clang=n
+       if tc-is-clang; then
+               clang=y
+       fi
+
+       # Send raw LDFLAGS so that --as-needed works
+       emake \
+               V=1 \
+               LDFLAGS="$(raw-ldflags)" \
+               HOSTCC="$(tc-getBUILD_CC)" \
+               HOSTCXX="$(tc-getBUILD_CXX)" \
+               clang="${clang}" \
+               "$@"
+}
+
+src_configure() {
+       cd xen || die
+
+       touch gentoo-config || die
+       if use arm; then
+          echo "CONFIG_EARLY_PRINTK=sun7i" >> gentoo-config || die
+       fi
+       if use debug; then
+               cat <<-EOF >> gentoo-config || die
+               CONFIG_DEBUG=y
+               CONFIG_CRASH_DEBUG=y
+EOF
+       fi
+       if use flask; then
+               echo "CONFIG_XSM=y" >> gentoo-config || die
+       fi
+
+       # remove flags
+       unset CFLAGS
+
+       tc-ld-disable-gold # Bug 700374
+
+       xen_make KCONFIG_ALLCONFIG=gentoo-config alldefconfig
+}
+
+src_compile() {
+       xen_make -C xen
+}
+
+src_install() {
+       # The 'make install' doesn't 'mkdir -p' the subdirs
+       if use efi; then
+               mkdir -p "${D}"${EFI_MOUNTPOINT}/efi/${EFI_VENDOR} || die
+       fi
+
+       xen_make DESTDIR="${D}" -C xen install
+
+       # make install likes to throw in some extra EFI bits if it built
+       use efi || rm -rf "${D}/usr/$(get_libdir)/efi"
+}
+
+pkg_postinst() {
+       elog "Official Xen Guide:"
+       elog " https://wiki.gentoo.org/wiki/Xen";
+
+       use efi && einfo "The efi executable is installed in /boot/efi/gentoo"
+
+       ewarn
+       ewarn "Xen 4.12+ changed the default scheduler to credit2 which can 
cause"
+       ewarn "domU lockups on multi-cpu systems. The legacy credit scheduler 
seems"
+       ewarn "to work fine."
+       ewarn
+       ewarn "Add sched=credit to xen command line options to use the legacy 
scheduler."
+       ewarn
+       ewarn 
"https://wiki.gentoo.org/wiki/Xen#Xen_domU_hanging_with_Xen_4.12.2B";
+}

diff --git a/app-emulation/xen/xen-4.16.4_pre1.ebuild 
b/app-emulation/xen/xen-4.16.4_pre1.ebuild
new file mode 100644
index 000000000000..637b34f05dfb
--- /dev/null
+++ b/app-emulation/xen/xen-4.16.4_pre1.ebuild
@@ -0,0 +1,174 @@
+# Copyright 1999-2023 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+PYTHON_COMPAT=( python3_{9..11} )
+
+inherit flag-o-matic mount-boot python-any-r1 toolchain-funcs
+
+if [[ ${PV} == *9999 ]]; then
+       inherit git-r3
+       EGIT_REPO_URI="git://xenbits.xen.org/xen.git"
+       SRC_URI=""
+else
+       KEYWORDS="~amd64 ~arm -x86"
+
+       XEN_GENTOO_PATCHSET_NUM=2
+       XEN_GENTOO_PATCHSET_BASE=4.16.1
+       XEN_PRE_PATCHSET_NUM=0
+       XEN_PRE_VERSION_BASE=4.16.3
+
+       XEN_BASE_PV="${PV}"
+       if [[ -n "${XEN_PRE_VERSION_BASE}" ]]; then
+               XEN_BASE_PV="${XEN_PRE_VERSION_BASE}"
+       fi
+
+       
SRC_URI="https://downloads.xenproject.org/release/xen/${XEN_BASE_PV}/xen-${XEN_BASE_PV}.tar.gz";
+
+       if [[ -n "${XEN_PRE_PATCHSET_NUM}" ]]; then
+               XEN_UPSTREAM_PATCHES_TAG="$(ver_cut 
1-3)-pre-patchset-${XEN_PRE_PATCHSET_NUM}"
+               
XEN_UPSTREAM_PATCHES_NAME="xen-upstream-patches-${XEN_UPSTREAM_PATCHES_TAG}"
+               SRC_URI+=" 
https://gitweb.gentoo.org/proj/xen-upstream-patches.git/snapshot/${XEN_UPSTREAM_PATCHES_NAME}.tar.bz2";
+               
XEN_UPSTREAM_PATCHES_DIR="${WORKDIR}/${XEN_UPSTREAM_PATCHES_NAME}"
+       fi
+       if [[ -n "${XEN_GENTOO_PATCHSET_NUM}" ]]; then
+               XEN_GENTOO_PATCHES_TAG="$(ver_cut 1-3 
${XEN_GENTOO_PATCHSET_BASE})-gentoo-patchset-${XEN_GENTOO_PATCHSET_NUM}"
+               
XEN_GENTOO_PATCHES_NAME="xen-gentoo-patches-${XEN_GENTOO_PATCHES_TAG}"
+               SRC_URI+=" 
https://gitweb.gentoo.org/proj/xen-gentoo-patches.git/snapshot/${XEN_GENTOO_PATCHES_NAME}.tar.bz2";
+               XEN_GENTOO_PATCHES_DIR="${WORKDIR}/${XEN_GENTOO_PATCHES_NAME}"
+       fi
+fi
+
+DESCRIPTION="The Xen virtual machine monitor"
+HOMEPAGE="https://xenproject.org";
+
+S="${WORKDIR}/xen-$(ver_cut 1-3 ${XEN_BASE_PV})"
+
+LICENSE="GPL-2"
+SLOT="0"
+IUSE="+boot-symlinks debug efi flask"
+REQUIRED_USE="arm? ( debug )"
+
+DEPEND="${PYTHON_DEPS}
+       efi? ( >=sys-devel/binutils-2.22[multitarget] )
+       !efi? ( >=sys-devel/binutils-2.22 )
+       flask? ( sys-apps/checkpolicy )"
+RDEPEND=""
+PDEPEND="~app-emulation/xen-tools-${PV}"
+
+# no tests are available for the hypervisor
+# prevent the silliness of /usr/lib/debug/usr/lib/debug files
+# prevent stripping of the debug info from the /usr/lib/debug/xen-syms
+RESTRICT="test splitdebug strip"
+
+# Approved by QA team in bug #144032
+QA_WX_LOAD="boot/xen-syms-${PV}"
+
+pkg_setup() {
+       python-any-r1_pkg_setup
+       if [[ -z ${XEN_TARGET_ARCH} ]]; then
+               if use amd64; then
+                       export XEN_TARGET_ARCH="x86_64"
+               elif use arm; then
+                       export XEN_TARGET_ARCH="arm32"
+               elif use arm64; then
+                       export XEN_TARGET_ARCH="arm64"
+               else
+                       die "Unsupported architecture!"
+               fi
+       fi
+}
+
+src_prepare() {
+       if [[ -v XEN_UPSTREAM_PATCHES_DIR ]]; then
+               eapply "${XEN_UPSTREAM_PATCHES_DIR}"
+       fi
+
+       if [[ -v XEN_GENTOO_PATCHES_DIR ]]; then
+               eapply "${XEN_GENTOO_PATCHES_DIR}"
+       fi
+
+       # Symlinks do not work on fat32 volumes # 829765
+       if ! use boot-symlinks || use efi; then
+               eapply 
"${XEN_GENTOO_PATCHES_DIR}"/no-boot-symlinks/${PN}-4.16-no-symlinks.patch
+       fi
+
+       # Workaround new gcc-11 options
+       sed -e '/^CFLAGS/s/-Werror//g' -i xen/Makefile || die
+
+       # Drop .config
+       sed -e '/-include $(XEN_ROOT)\/.config/d' -i Config.mk || die "Couldn't 
drop"
+
+       if use efi; then
+               export EFI_VENDOR="gentoo"
+               export EFI_MOUNTPOINT="/boot"
+       fi
+
+       default
+}
+
+xen_make() {
+       # Setting clang to either 'y' or 'n' tells Xen's build system
+       # whether or not clang is used.
+       local clang=n
+       if tc-is-clang; then
+               clang=y
+       fi
+
+       # Send raw LDFLAGS so that --as-needed works
+       emake \
+               V=1 \
+               LDFLAGS="$(raw-ldflags)" \
+               HOSTCC="$(tc-getBUILD_CC)" \
+               HOSTCXX="$(tc-getBUILD_CXX)" \
+               CC="$(tc-getCC)" \
+               CXX="$(tc-getCXX)" \
+               LD="$(tc-getLD)" \
+               AR="$(tc-getAR)" \
+               OBJDUMP="$(tc-getOBJDUMP)" \
+               RANLIB="$(tc-getRANLIB)" \
+               clang="${clang}" \
+               "$@"
+}
+
+src_configure() {
+       cd xen || die
+
+       touch gentoo-config || die
+       if use arm; then
+          echo "CONFIG_EARLY_PRINTK=sun7i" >> gentoo-config || die
+       fi
+       if use debug; then
+               cat <<-EOF >> gentoo-config || die
+               CONFIG_DEBUG=y
+               CONFIG_CRASH_DEBUG=y
+EOF
+       fi
+       if use flask; then
+               echo "CONFIG_XSM=y" >> gentoo-config || die
+       fi
+
+       # remove flags
+       unset CFLAGS
+
+       tc-ld-disable-gold # Bug 700374
+
+       xen_make KCONFIG_ALLCONFIG=gentoo-config alldefconfig
+}
+
+src_compile() {
+       xen_make -C xen
+}
+
+src_install() {
+       # The 'make install' doesn't 'mkdir -p' the subdirs
+       if use efi; then
+               mkdir -p "${D}"${EFI_MOUNTPOINT}/efi/${EFI_VENDOR} || die
+       fi
+
+       xen_make DESTDIR="${D}" -C xen install
+
+       # make install likes to throw in some extra EFI bits if it built
+       use efi || rm -rf "${D}/usr/$(get_libdir)/efi"
+}

Reply via email to